window.addEventListener('DOMContentLoaded', function() {

  var textField = document.getElementById('textcontents'),
      centerKey = document.getElementById('softkey-center'),
      titleBar = document.querySelector('#title h1'),
      scrollStep = 20, largeScrollStep = 80,
      translate = navigator.mozL10n.get,
      computedStyle = window.getComputedStyle(textField),
      defaultFontSize = computedStyle.fontSize,
      currentZoom = 1, zoomStep = 0.2;
  
  navigator.mozL10n.once(start);

  function start() {
    
  }
  
  function setTitle(fileName) {
    let name = fileName.split('/').pop()
    titleBar.textContent = name
  }
  
  function zoom(num) {
    textField.style.fontSize = num+'rem'
  }

  window.addEventListener('keydown', function(e) {
   switch(e.key) {
     case 'ArrowUp': //scroll up
       textField.scrollTop -= scrollStep;
       if(textField.scrollTop < 0) textField.scrollTop = 0
       break;
     case 'ArrowLeft': //large scroll up
       textField.scrollTop -= largeScrollStep;
       if(textField.scrollTop < 0) textField.scrollTop = 0
       break;
     case 'ArrowDown': //scroll down
       textField.scrollTop += scrollStep;
       if(textField.scrollTop > textField.scrollHeight) textField.scrollTop = textField.scrollHeight
       break;
     case 'ArrowRight': //large scroll down
       textField.scrollTop += largeScrollStep;
       if(textField.scrollTop > textField.scrollHeight) textField.scrollTop = textField.scrollHeight
       break;
     case 'SoftLeft': //zoom out
       currentZoom -= zoomStep
       if(currentZoom !== 1)
         centerKey.textContent = 'DEFAULT'
       else
         centerKey.textContent = 'FONT'
       zoom(currentZoom)
       break;
     case 'SoftRight': //zoom in
       currentZoom += zoomStep
       if(currentZoom !== 1)
         centerKey.textContent = 'DEFAULT'
       else
         centerKey.textContent = 'FONT'
       zoom(currentZoom)
       break;
     //zoom to default
     //if already zoomed, switch between proportional and monospace font
     case 'Enter':
       computedStyle = window.getComputedStyle(textField)
       if(currentZoom === 1) {
         textField.classList.toggle('monospace');
       } else {
         currentZoom = 1
         centerKey.textContent = 'FONT'
         zoom(currentZoom)
       }
       break;
     case '*': //switch theme
       textField.parentElement.classList.toggle('alt-theme')
       textField.classList.toggle('alt-theme')
       break;
     case '#': //open file
       var picker = new MozActivity({
          name: "xyz.831337.textr.pickFile",
          data: {
            types: ["text/plain"],
            prefix: "texts"
          }
       })
       picker.onsuccess = function() {
         var fileObj = this.result.file
         var fr = new FileReader()
         fr.onload = function(e) {
           setTitle(fileObj.name)
           textField.value = e.target.result
         }
         fr.readAsText(fileObj)
       }
       break;
     default: //spatial navigation
       if(parseInt(e.key) == e.key) {
         var navVal = parseInt(e.key);
         textField.scrollTop = textField.scrollHeight * navVal / 10;
       }
   }
  }, false)
});