window.addEventListener('DOMContentLoaded', function() {
  var mainlist = document.getElementById('filepicker')
  var items = [], textIndex = 0
  var activityHandler = null
  var fileTypes = ["text/plain"], defPathPrefix = "texts"
  
  function refreshFileList() {
    mainlist.innerHTML = ''
    for(let i=0,l=items.length;i<l;i++) {
      let item = document.createElement('div')
      item.innerHTML = items[i].name/* + ' (' + items[i].type + ')'*/
      item.classList.add('picker-file')
      mainlist.appendChild(item)
    }
    mainlist.children[0].classList.add('active')
  }
  
  function rescanFiles(mimeTypes, pathPrefix) {
    items = []
    let sdcards = navigator.getDeviceStorages('sdcard'), storageAmount = sdcards.length
    for(let i=0;i<storageAmount;i++) {
      let fileCursor = sdcards[i].enumerate(pathPrefix)
      fileCursor.onsuccess = function() {
        if(fileCursor.result.name !== null) {
          let file = fileCursor.result;
          if(mimeTypes.indexOf(file.type.toLowerCase().split(';')[0].trim()) > -1) {
            items.push(file)
            refreshFileList()
          }
          fileCursor.continue()
        }
      }
    }
  }
  
  navigator.mozSetMessageHandler('activity', function(activityRequest) {
    option = activityRequest.source

    if(option.name === "xyz.831337.textr.pickFile") {
      activityHandler = activityRequest
      fileTypes = option.data.types
      defPathPrefix = option.data.prefix
      rescanFiles(fileTypes, defPathPrefix)
    }
  })
  
  function selectFileByIndex() {
    [].forEach.call(mainlist.children, function(el) {
      el.classList.remove('active')
    })
    let activeElem = mainlist.children[textIndex]
    activeElem.classList.add('active')
    if(activeElem.offsetTop > mainlist.offsetHeight)
      mainlist.scrollTop = activeElem.offsetTop
    else mainlist.scrollTop = 0
  }
  
  window.addEventListener('keydown', function(e) {
   switch(e.key) {
     case 'ArrowUp': //scroll up
     case 'ArrowLeft':
       textIndex--
       if(textIndex < 0) textIndex = items.length -1
       selectFileByIndex()
       break;
     case 'ArrowDown': //scroll down
     case 'ArrowRight':
       textIndex++
       if(textIndex > (items.length - 1) ) textIndex = 0
       selectFileByIndex()
       break;
     case 'SoftRight': //go back
       activityHandler.postError('No file selected')
       break;
     case 'Enter': //pick the file
       var currentFile = items[textIndex]
       if(currentFile)
         activityHandler.postResult({file: items[textIndex]})
       else
         activityHandler.postError('No file selected')
       break;
   }})
  
}, false)